#ifndef MATRIXUDG_H
#define MATRIXUDG_H

#include "MeshDefinition.h"
#include "FindGeodesic.h"
#include "EData.h"
#include <Eigen/Dense>

using namespace Eigen;

class MatrixUDG
{
public:
	MatrixUDG();
	~MatrixUDG();
	MatrixUDG(const Mesh & mesh_, std::vector<int> & vertex);
	MatrixUDG(Mesh & mesh_, std::vector<int> & vertex, std::vector<std::vector<double>> & edges_wei);

	void kruskal();

	std::vector<EData> spanning_tree_path;//СڽӾеı
	std::vector<std::vector<int>> spanning_tree_edges1;//СӦmesh1е·ϵĵ

private:
	std::vector<EData> getEdges();
	int getPosition(int index);

private:
	Mesh my_mesh1;
	std::vector<int> input_vertex1;        //1жӦ
	int nv;                      //ͼж
	int ne;                      //ͼб߸
	MatrixXd weight_Matrix;      //ڽӾ
	std::vector<std::vector<int>> shortest_edges1;//mesh1ÿϵ·
	Findgeodesic * find_geodesic1;

	std::vector<int> visit_or_not1;//ж1еıǷѾʣ1ʾʣ-1ʾδ
	std::vector<int> visit_or_not_vertex1;//ж1еĵǷ񱻷ʣ1ʾʣ-1ʾδʣ0ʾlandmarks
};

#endif // MATRIXUDG_H